import { CallbackT } from "node-opcua-status-code";
export type StraightFunc<T, This> = (this: This) => T;
export type PromiseFunc<T, This> = (this: This) => Promise<T>;
export type CallbackFunc<T, This> = (this: This, callback: CallbackT<T>) => void;
export type MultiformFunc<T, This> = StraightFunc<T, This> | PromiseFunc<T, This> | CallbackFunc<T, This>;
export declare function convertToCallbackFunction<T, This>(func: MultiformFunc<T, This>): CallbackFunc<T, This>;
export type StraightFunc1<T, P, This> = (this: This, param1: P) => T;
export type PromiseFunc1<T, P, This> = (this: This, param1: P) => Promise<T>;
export type CallbackFunc1<T, P, This> = (this: This, param1: P, callback: CallbackT<T>) => void;
export type MultiformFunc1<T, P, This> = StraightFunc1<T, P, This> | PromiseFunc1<T, P, This> | CallbackFunc1<T, P, This>;
export declare function convertToCallbackFunction1<T, P, This>(func: MultiformFunc1<T, P, This>): CallbackFunc1<T, P, This>;
