import { IAddressSpace } from "node-opcua-address-space-base";
import { ErrorCallback } from "node-opcua-status-code";
import { SimpleCallback } from "node-opcua-xml2json";
import { NodeSetLoaderOptions } from "../interfaces/nodeset_loader_options";
export interface NodeSet2ParserEngine {
    addNodeSet: (xmlData: string, callback1: SimpleCallback) => void;
    terminate: (callback: SimpleCallback) => void;
}
export declare class NodeSetLoader {
    private options?;
    _s: NodeSet2ParserEngine;
    constructor(addressSpace: IAddressSpace, options?: NodeSetLoaderOptions | undefined);
    addNodeSet(xmlData: string, callback: ErrorCallback): void;
    addNodeSetAsync(xmlData: string): Promise<void>;
    terminate(callback: ErrorCallback): void;
    terminateAsync(): Promise<void>;
}
