import { DataTypeFactory, FieldCategory, IStructuredTypeSchema, TypeDefinition } from "node-opcua-factory";
import { NodeId } from "node-opcua-nodeid";
import { IBasicSessionAsync2 } from "node-opcua-pseudo-session";
import { DataTypeDefinition } from "node-opcua-types";
import { DataTypeAndEncodingId } from "node-opcua-schemas";
export interface CacheForFieldResolution {
    fieldTypeName: string;
    schema: TypeDefinition;
    category: FieldCategory;
    allowSubType?: boolean;
    dataType?: NodeId;
}
export interface IDataTypeDescriptionMini {
    encodings?: DataTypeAndEncodingId;
    isAbstract?: boolean;
}
export declare function convertDataTypeDefinitionToStructureTypeSchema(session: IBasicSessionAsync2, dataTypeNodeId: NodeId, name: string, definition: DataTypeDefinition, dataTypeDescription: IDataTypeDescriptionMini | null, dataTypeFactory: DataTypeFactory, isAbstract: boolean, cache: {
    [key: string]: CacheForFieldResolution;
}): Promise<IStructuredTypeSchema>;
