"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.readMaxByteStringLength = readMaxByteStringLength;
const node_opcua_basic_types_1 = require("node-opcua-basic-types");
const node_opcua_binary_stream_1 = require("node-opcua-binary-stream");
const node_opcua_constants_1 = require("node-opcua-constants");
const node_opcua_nodeid_1 = require("node-opcua-nodeid");
const node_opcua_status_code_1 = require("node-opcua-status-code");
async function readMaxByteStringLength(session) {
    const dataValue = await session.read({
        nodeId: (0, node_opcua_nodeid_1.resolveNodeId)(node_opcua_constants_1.VariableIds.Server_ServerCapabilities_MaxByteStringLength),
        attributeId: node_opcua_basic_types_1.AttributeIds.Value
    });
    if (dataValue.statusCode !== node_opcua_status_code_1.StatusCodes.Good) {
        return 1024;
    }
    return dataValue.value.value || node_opcua_binary_stream_1.BinaryStream.maxByteStringLength;
}
//# sourceMappingURL=read_max_byte_string_length.js.map