/**
 * |           |                                                            |
 * |-----------|------------------------------------------------------------|
 * | namespace |http://opcfoundation.org/UA/                                |
 * | nodeClass |DataType                                                    |
 * | name      |NodeClass                                                   |
 * | isAbstract|false                                                       |
 */
export declare enum EnumNodeClass {
    /**
     * No value is specified.
     */
    Unspecified = 0,
    /**
     * The Node is an Object.
     */
    Object = 1,
    /**
     * The Node is a Variable.
     */
    Variable = 2,
    /**
     * The Node is a Method.
     */
    Method = 4,
    /**
     * The Node is an ObjectType.
     */
    ObjectType = 8,
    /**
     * The Node is a VariableType.
     */
    VariableType = 16,
    /**
     * The Node is a ReferenceType.
     */
    ReferenceType = 32,
    /**
     * The Node is a DataType.
     */
    DataType = 64,
    /**
     * The Node is a View.
     */
    View = 128
}
