import { DataType } from "node-opcua-variant";
import { Byte } from "node-opcua-basic-types";
import { EnumTsnTalkerStatus } from "./enum_tsn_talker_status";
import { EnumTsnListenerStatus } from "./enum_tsn_listener_status";
import { EnumTsnFailureCode } from "./enum_tsn_failure_code";
import { UABaseInterface, UABaseInterface_Base } from "./ua_base_interface";
import { UABaseDataVariable } from "./ua_base_data_variable";
/**
 * |                |                                                            |
 * |----------------|------------------------------------------------------------|
 * |namespace       |http://opcfoundation.org/UA/                                |
 * |nodeClass       |ObjectType                                                  |
 * |typedDefinition |IIeeeBaseTsnStatusStreamType i=24183                        |
 * |isAbstract      |true                                                        |
 */
export interface UAIIeeeBaseTsnStatusStream_Base extends UABaseInterface_Base {
    talkerStatus?: UABaseDataVariable<EnumTsnTalkerStatus, DataType.Int32>;
    listenerStatus?: UABaseDataVariable<EnumTsnListenerStatus, DataType.Int32>;
    failureCode: UABaseDataVariable<EnumTsnFailureCode, DataType.Int32>;
    failureSystemIdentifier: UABaseDataVariable<Byte[], DataType.Byte>;
}
export interface UAIIeeeBaseTsnStatusStream extends UABaseInterface, UAIIeeeBaseTsnStatusStream_Base {
}
