import { VariableIds } from "node-opcua-constants";
import { IBasicSessionReadAsyncMultiple } from "./basic_session_interface";
export declare const serverCapabilitiesIds: VariableIds[];
export interface OperationLimits {
    maxNodesPerRead?: number;
    maxNodesPerBrowse?: number;
    maxNodesPerWrite?: number;
    maxNodesPerMethodCall?: number;
    maxNodesPerRegisterNodes?: number;
    maxNodesPerNodeManagement?: number;
    maxMonitoredItemsPerCall?: number;
    maxNodesPerHistoryReadData?: number;
    maxNodesPerHistoryReadEvents?: number;
    maxNodesPerHistoryUpdateData?: number;
    maxNodesPerHistoryUpdateEvents?: number;
    maxNodesPerTranslateBrowsePathsToNodeIds?: number;
}
export declare function readOperationLimits(session: IBasicSessionReadAsyncMultiple): Promise<OperationLimits>;
